<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card>
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isSubmitted">
      <h1>Praca zaliczeniowa</h1>
      <form @submit.prevent="submitForm" class="formStyling">
        <div class="form-control" :class="{ invalid: !file.isValid }">
          <label for="image">Plik z pracą</label>
          <input
            type="file"
            id="file"
            accept=".jpg, .jpeg, .png"
            @change="addFile"
            @blur="clearValidity('file')"
          />
          <p v-if="!file.isValid">Wybierz plik.</p>
        </div>
        <div class="button">
          <base-button>Wyślij pracę</base-button>
        </div>
      </form>
    </div>
    <div v-else-if="isSubmitted">
      <h1>Praca zaliczeniowa została wysłana.</h1>
    </div>
  </base-card>
</template>

<script setup>
import { ref, defineProps, defineEmits } from "vue";
import { useStore } from "vuex";

const store = useStore();

const props = defineProps(["uuid"]);
const emits = defineEmits(["changeStatus"]);

const file = ref({
  val: "",
  isValid: true,
});
const formIsValid = ref(true);
const isLoading = ref(false);
const error = ref(null);
const isSubmitted = ref(false);

function clearValidity(input) {
  this[input].isValid = true;
}

function handleError() {
  error.value = null;
}

function addFile(e) {
  file.value.val = e.target.files[0];
  createBase64Image(file.value.val);
}

function createBase64Image(fileObject) {
  const reader = new FileReader();

  reader.onload = (e) => {
    file.value.val = e.target.result;
  };
  reader.readAsDataURL(fileObject);
}

function validateForm() {
  formIsValid.value = true;
  if (file.value.val === "") {
    file.value.isValid = false;
    formIsValid.value = false;
  }
}

async function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  isLoading.value = true;
  try {
    await store.dispatch("submitWork", {
      workId: props.uuid,
      userId: store.getters.userId,
      file: file.value.val,
    });
    isSubmitted.value = true;
    await emits("changeStatus");
  } catch (er) {
    error.value = er.message || "Nie udało się wysłać pracy zaliczeniowej.";
  }
  isLoading.value = false;
}
</script>
